package com.bjsxt.homeWork;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;
import java.util.TreeSet;

/**
 * 使用HashSet和TreeSet存储多个商品信息，遍历并输出；
 * 其中商品属性：编号，名称，单价，出版社；要求向其中添加多个相同的商品，
 * 验证集合中元素的唯一性。
 * 提示：向HashSet中添加自定义类的对象信息，需要重写hashCode和equals();
 * 向TreeSet中添加自定义类的信息，需要实现Comparable接口,指定比较规则；
 * */

public class HomeWork2 {
    public static void main(String[] args) {
        Set<Commodity> set = new HashSet<>();
        Commodity c1 = new Commodity(1001,"come",10.03,"code");
        Commodity c2 = new Commodity(1002,"we",11.03,"ucode");
        Commodity c3 = new Commodity(1003,"wel",40.03,"ncode");
        Commodity c4 = new Commodity(1004,"me",13.03,"unde");
        Commodity c5 = new Commodity(1005,"com",70.03,"de");
        set.add(c1);
        set.add(c2);
        set.add(c3);
        set.add(c4);
        set.add(c5);
        set.add(c1);
        set.add(c1);
        set.add(c1);
        set.add(c1);
        set.add(c3);
        set.add(c1);
        set.add(c3);
        for(Commodity c:set){
            System.out.println(c);
        }
        System.out.println("------------------");
        Set<Commodity> set1 = new TreeSet<>();
        Commodity commodity = new Commodity(1,"a",1,"a");
        Commodity commodity1 = new Commodity(2,"b",1,"a");
        Commodity commodity2 = new Commodity(3,"c",1,"a");
        Commodity commodity3 = new Commodity(4,"d",1,"a");
        set1.add(commodity);
        set1.add(commodity1);
        set1.add(commodity2);
        set1.add(commodity3);
        set1.add(commodity3);
        set1.add(commodity3);

        for(Commodity c:set1){
            System.out.println(c);
        }


    }
}

class Commodity implements Comparable<Commodity>{
    private int num;
    private String name;
    private double money;
    private String made;

    public Commodity(int num, String name, double money, String made) {
        this.num = num;
        this.name = name;
        this.money = money;
        this.made = made;
    }

    public Commodity() {
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Commodity commodity = (Commodity) o;
        return num == commodity.num &&
                Double.compare(commodity.money, money) == 0 &&
                Objects.equals(name, commodity.name) &&
                Objects.equals(made, commodity.made);
    }

    @Override
    public int hashCode() {
        return Objects.hash(num, name, money, made);
    }

    public int getNum() {
        return num;
    }

    public void setNum(int num) {
        this.num = num;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public double getMoney() {
        return money;
    }

    public void setMoney(double money) {
        this.money = money;
    }

    public String getMade() {
        return made;
    }

    public void setMade(String made) {
        this.made = made;
    }



    @Override
    public String toString() {
        return "Commodity{" +
                "num=" + num +
                ", name='" + name + '\'' +
                ", money=" + money +
                ", made='" + made + '\'' +
                '}';
    }

    @Override
    public int compareTo(Commodity o) {
        if(this.num>o.num){
            return 1;
        }
        if(this.num==o.num){
            this.name.compareTo(o.getName());
        }
        return -1;
    }
}
